<?xml version="1.0" encoding="utf-8"?>
<collection>

<lib_version>
    >=2.0.0
</lib_version>

<spec_type>
  <kind>
      common_env
  </kind>

  <init_code>
      g_type_init();
  </init_code>

  <libs>
      libgobject-2.0.so
  </libs>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GInitiable*
  </data_type>

  <value>
      g_initable_new()
  </value>

  <global_code>
      #include <gio/gio.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GAsyncInitable*
  </data_type>

  <value>
      G_ASYNC_INITABLE($[g_object_newv])
  </value>

  <global_code>
      #include <gio/gio.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GEmblemedIcon*
  </data_type>

  <value>
      $[g_emblemed_icon_new]
  </value>

  <global_code>
      #include <gio/gio.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GAsyncResult*
  </data_type>

  <value>
      $[g_simple_async_result_new]
  </value>

  <global_code>
      #include <gio/gio.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GObject*
  </data_type>

  <value>
      g_object_new(G_TYPE_OBJECT, NULL)
  </value>

  <global_code>
      #include <glib.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GFileDescriptorBased*
  </data_type>

  <value>
      $[g_file_read]
  </value>

  <global_code>
      #include <gio/gio.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GSocketFamily
  </data_type>

  <value>
      G_SOCKET_FAMILY_IPV4
  </value>

  <global_code>
      #include <gio/gio.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GUnixMountPoint*
  </data_type>

  <value>
      $(GUnixMountEntry*)
  </value>

  <global_code>
      #include <gio/gunixmounts.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GArray*
  </data_type>

  <init_code>
      g_array_insert_vals($0, 0, malloc(16), 4);
  </init_code>

  <global_code>
      #include <glib.h>
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GDate*
  </data_type>

  <value>
      $[g_date_new_julian]
  </value>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      guint
  </data_type>

  <value>
      sizeof(GHook)
  </value>

  <associating>
      <interfaces>
          g_hook_list_init
      </interfaces>
    
      <links>
          param2
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      guint
  </data_type>

  <value>
      sizeof(GClosure)
  </value>

  <associating>
      <interfaces>
          g_closure_new_object
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      normal
  </kind>

  <data_type>
      gchar const*
  </data_type>

  <value>
      G_VARIANT_TYPE_ARRAY
  </value>

  <associating>
      <interfaces>
          g_variant_type_new
      </interfaces>
    
      <links>
          param1
      </links>
  </associating>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GValueArray*
  </data_type>

  <init_code>
      init_GValueArray($0);
  </init_code>

  <global_code>
      void init_GValueArray(GValueArray* array)
      {
          GValue value = {0};
          g_value_init (&value, G_TYPE_STRING);
          g_value_array_append(array, &value);
          g_value_array_append(array, &value);
      }
  </global_code>
</spec_type>

<spec_type>
  <kind>
      common_param
  </kind>

  <data_type>
      GValue*
  </data_type>

  <value>
      $[g_value_array_get_nth]
  </value>
</spec_type>

</collection>
